#pragma once

#include "FileSystemPath.h"
#include "String.h"

class BuildLibrary
{
public:
    BuildLibrary() = default;

    BuildLibrary(const FileSystemPath& build_config);

    Status scan();

    const Vector<FileSystemPath>& get_sources() const;

    const Vector<FileSystemPath>& get_include_dirs() const;

private:
    FileSystemPath m_build_config;
    Vector<FileSystemPath> m_sources;
    Vector<FileSystemPath> m_include_dirs;
    String m_name;
};