#pragma once

#include "String.h"
#include "File.h"
#include "Vector.h"
#include "CharUtils.h"

class KScopeLexer
{
public:
    enum class TokenT
    {
        NONE,
        DEF, // LANG COMMANDS
        EXTERN,
        IDENTIFIER ,// GENERAL
        LITERAL,
        NUMBER
    };

    struct Token
    {
        bool is_identifier() const 
        {
            return m_type == TokenT::IDENTIFIER;
        }

        bool is_number() const 
        {
            return m_type == TokenT::NUMBER;
        }

        void set_is_identifier()
        {
            m_type = TokenT::IDENTIFIER;
        }

        void set_is_number()
        {
            m_type = TokenT::NUMBER;
        }

        void set_is_literal()
        {
            m_type = TokenT::LITERAL;
        }

        void on_identifier_finished()
        {
            if (m_value == "def")
            {
                m_type = TokenT::DEF;
            }
            else if (m_value == "extern")
            {
                m_type = TokenT::EXTERN;
            }
        }

        void on_number_finished()
        {

        }

        void on_finished()
        {
            if (is_identifier())
            {
                on_identifier_finished();
            }
            else if(is_number())
            {
                on_number_finished();
            }
        }

        TokenT m_type{TokenT::NONE};
        String m_value;
    };

    void run(const FileSystemPath& path);

    void on_token_finished(Vector<Token>& tokens);

    Token m_working_token;
};