#include "Dictionary.h"

bool Dictionary::hasKey(const String& key) const
{
    return hasStringKey(key) || hasDictKey(key);
}

bool Dictionary::hasStringKey(const String& key) const
{
    return mStringData.has_key(key);
}

bool Dictionary::hasDictKey(const String& key) const
{
    return mDictData.has_key(key);
}

Vector<String> Dictionary::getStringKeys() const
{
    Vector<String> keys;
    for (const auto& item : mStringData)
    {
        keys.push_back(item.key());
    }
    return keys;
}

Vector<String> Dictionary::getDictKeys() const
{
    Vector<String> keys;
    for (const auto& item : mDictData)
    {
        keys.push_back(item.key());
    }
    return keys;
}

Dictionary* Dictionary::getDict(const String& key) const
{
    //return (*mDictData.find(key)).value().get();
    return nullptr;
}

String Dictionary::getItem(const String& key) const
{
    return (*mStringData.find(key)).value();
}

void Dictionary::addStringItem(const String& key, const String& item)
{
    mStringData.insert(key, item);
}

void Dictionary::addDictItem(const String& key, Ptr<Dictionary> dict)
{
    mDictData.insert(key, std::move(dict));
}
