#pragma once
#include "String.h"
#include "Vector.h"
#include "Map.h"
#include "Pointer.h"

class Dictionary
{
public:
    Dictionary() = default;
    virtual ~Dictionary() = default;

    void addStringItem(const String& key, const String& item);

    void addDictItem(const String& key, Ptr<Dictionary> dict);

    Dictionary* getDict(const String& key) const;

    Vector<String> getDictKeys() const;

    Vector<String> getStringKeys() const;

    String getItem(const String& key) const;

    bool hasKey(const String& key) const;

    bool hasStringKey(const String& key) const;

    bool hasDictKey(const String& key) const;
    
protected:
    Map<String, String> mStringData;
    Map<String, Ptr<Dictionary> > mDictData;
};
