#pragma once

template<typename T>
class Optional{

public:
    Optional() = default;

    Optional(const T& value)
        : m_is_set(true),
            m_value(value)
    {

    }

    const T& value() const
    {
        return m_value;
    }

    bool is_set() const 
    {
        return m_is_set;
    }

    operator bool() const 
    {
        return m_is_set;
    }

private:
    bool m_is_set{false};
    T m_value;
};