#pragma once

#include "Vector.h"
#include "FileSystemPath.h"
#include "Result.h"

class Directory
{
public:
    static Status getDirectoryContents(const FileSystemPath& path, 
        Vector<FileSystemPath>& content, bool directoryOnly=false);

    static Status create(const FileSystemPath& path, bool existsOK = false);

    static Status getAllSubDirectories(const FileSystemPath& path, 
        Vector<FileSystemPath>& content);

    static Status getFiles(const FileSystemPath& path, 
        Vector<FileSystemPath>& content, 
        bool recursive=false,
        const String& extension = {});

    static Status getFilesWithExtension(const FileSystemPath& path, 
        const String& extension, 
        Vector<FileSystemPath>& content, 
        bool recursive=false);
};
