#include "FileFormats.h"

#include "StringUtils.h"

FileFormat::ExtensionMap FileFormat::mExtensions = []
{
    ExtensionMap ret;
    //ret.insert(Format::Markdown, ".md");
    //ret.insert(Format::Html, ".html");
    //ret.insert(Format::Wav, ".wav");
    return ret;
}();

bool FileFormat::isFormat(const String& extension, Format format)
{
    return String::to_lower(extension) == (*mExtensions.find(format)).value();
}

FileFormat::Format FileFormat::inferFormat(const String& query)
{
    for(const auto& extension : mExtensions)
    {
        if(extension.value() == query)
        {
            return extension.key();
        }
    }
    return Format::Unknown;
}

String FileFormat::getExtension(Format format)
{
    return (*mExtensions.find(format)).value();
}
