#pragma once

#include <stdlib.h>
#include <utility>

template<typename T>
class Allocator
{
public:
    template<class U>
    T* allocate(U&& u)
    {
        return new T(std::forward<U>(u));
    }

    T* allocate()
    {
        return new T();
    }

    void do_delete(T* p)
    {
        delete p;
    }

    T* alloc_array(size_t size)
    {
        return new T[size];
    }

    void delete_array(T*& arr)
    {
        delete[] arr;
    }
};