#pragma once

#include "HttpHeader.h"
#include "HttpPreamble.h"

#include "String.h"

class HttpRequest
{
public:

    enum class Verb
    {
        GET,
        PUT,
        POST,
        PATCH,
        _DELETE,
        UNKNOWN
    };

    HttpRequest() = default;

    HttpRequest(Verb verb, const String& path = {});

    Verb getVerb() const;

    String getPath() const;

    void fromString(const String& string);

    String toString(const String& host) const;

    size_t requiredBytes() const;

private:
    Verb mVerb = Verb::UNKNOWN;

    HttpHeader mHeader;
    HttpPreamble mPreamble;

    unsigned mRequiredBytes{ 0 };
};
