#pragma once

#include "Stream.h"
#include "String.h"
#include "Optional.h"
#include "ByteTypes.h"

class BinaryStream
{
public:

    template<typename T>
    static bool write(OutputStream<Byte>* stream, T data)
    {
        stream->write(reinterpret_cast<Byte*>(&data), sizeof(data));
        return true;
    }

    static Optional<Byte> getNextByte(InputStream<Byte>& stream);

    static bool getNextNBytes(InputStream<Byte>& stream, Byte* buffer, size_t numBytes);

    static bool getNextWord(InputStream<Byte>& stream, Byte* buffer);

    static bool getNextDWord(InputStream<Byte>& stream, Byte* buffer);

    static bool getNextQWord(InputStream<Byte>& stream, Byte* buffer);

    static Optional<Word> getNextWord(InputStream<Byte>& stream, bool reverse = true);

    static Optional<DWord> getNextDWord(InputStream<Byte>& stream);

    static Optional<QWord> getNextQWord(InputStream<Byte>& stream);

    static bool checkNextDWord(InputStream<Byte>& stream, DWord target);

    static bool getNextString(InputStream<Byte>& stream, String& target, size_t numBytes);
};
