#pragma once

#include "BitStream.h"

class BufferBitStream : public BitStream
{
public:
    const VecBytes& getBuffer() const;

    bool isFinished() const override;

    void peekNextNBytes(size_t n, VecBytes& bytes) const override;

    Optional<uint8_t> readNextByte() override;

    void reset() override;

    void setBuffer(const VecBytes& data);

    void writeByte(uint8_t data, bool checkOverflow = true) override;

    void writeBytes(const VecBytes& data) override;

private:
    VecBytes mBuffer;
};
