#pragma once

#include "BitStream.h"
#include "Stream.h"
#include "ByteTypes.h"

class OutputBitStream : public BitStream
{
public:
    OutputBitStream(OutputStream<Byte>* stream);

    bool isFinished() const override;

    void peekNextNBytes(size_t n, VecBytes& bytes) const override;

    Optional<Byte> readNextByte() override;

    void writeByte(Byte data, bool checkOverflow = true) override;

    void writeBytes(const VecBytes& data) override;

private:
    OutputStream<Byte>* mStream{nullptr};
};
