#pragma once

#include "Map.h"
#include "Pointer.h"
#include "Vector.h"
#include <thread>
#include <mutex>
#include <atomic>


class ThreadCollection
{
public:
	bool add(Ptr<std::thread> thread);

	void joinAndClearAll();

	void markForRemoval(std::thread::thread::id inputId);

	void removeMarked();

	size_t size() const;

private:
	void _remove(std::thread::thread::id inputId);

	mutable std::mutex mMutex;
	std::atomic<bool> mAccepting{ true };

	Vector<std::thread::thread::id> mMarkedForRemoval;
	Map<std::thread::thread::id, Ptr<std::thread> > mThreads;
};