#pragma once

#include "SqliteInterface.h"
#include "Database.h"

#include "Pointer.h"
#include <filesystem>

using Path = std::filesystem::path;

class DatabaseManager
{
public:
    DatabaseManager();

    ~DatabaseManager();

    static Ptr<DatabaseManager> Create();

    void openDatabase(const Path& path);

    void run(const String& statement);

    void onShutDown();

private:
    DatabasePtr mDatabase;
    SqliteInterfacePtr mDatabaseInterface;
};

using DatabaseManagerPtr = Ptr<DatabaseManager>;
