#pragma once

#include "Pointer.h"
#include "Vector.h"

#include "HttpClient.h"
#include "HttpServer.h"

class AbstractWebApp;

class NetworkManager
{
public:
    NetworkManager();

    ~NetworkManager();

    static Ptr<NetworkManager> Create();

    HttpClient* getHttpClient() const;

    void runHttpServer(AbstractWebApp* webApp);

private:
    Ptr<HttpServer> mHttpServer;
    Ptr<HttpClient> mHttpClient;
};

using NetworkManagerUPtr = Ptr<NetworkManager>;
