#include "BuildSession.h"
#include "ConsoleLogger.h"

int main(int argc, char** argv)
{
    if (argc == 1)
    {
        LOG_ERROR("Missing arg with path to source dir");
        return -1;
    }

    BuildSession build(argv[1]);
    const auto scan_status = build.scan();
    if (!scan_status.ok())
    {
        LOG_ERROR("Scan failed with " << scan_status.error().msg());
        return -1;
    }

    const auto build_status = build.build();
    if (!build_status.ok())
    {
        LOG_ERROR("Build failed with " << build_status.error().msg());
        return -1;
    }
    return 0;
}
