#pragma once

#include "Pointer.h"
#include "String.h"

class AudioDevice
{

public:
    AudioDevice();

    ~AudioDevice();

    static Ptr<AudioDevice> Create();

    unsigned getSampleRate() const;

    unsigned getNumChannels() const;

    unsigned getPeriod() const;

    size_t getBufferSize() const;

    bool getIsOpen() const;

    String getName() const;

    void setName(const String& name);

    void setNumChannels(unsigned numChannels);

    void setPeriod(unsigned period);

    void setBufferSize(size_t bufferSize);

    void setSampleRate(unsigned rate);

    void setIsOpen(bool isOpen);
private:
    String mName {"unset"};
    unsigned mSampleRate {44100};
    unsigned mNumChannels {1};
    unsigned mPeriod {2};
    size_t mBufferSize{0};
    bool mIsOpen{false};
};

using AudioDevicePtr = Ptr<AudioDevice>;
