#pragma once

#include "BitStream.h"

#include "Image.h"

#include <cstdint>

class ImageBitStream : public BitStream
{
public:
    ImageBitStream(Image* image);

    bool isFinished() const override;

    Vector<uint8_t> peekNextNBytes(size_t n) const override;

    Optional<uint8_t> readNextByte() override;

    void writeByte(uint8_t data, bool checkOverflow = true) override;

    void writeBytes(const Vector<uint8_t>&) override
    {

    }

    unsigned getBytesPerScanline() const
    {
        return mImage->getBytesPerRow();
    }

private:
    Image* mImage{nullptr};
};
