#pragma once

#include "LineEndNode.h"

#include "Vector.h"

class Plot;
class LineNode;
class PlotCaptionNode;
class PlotSeriesNode;

class PlotNode : public AbstractVisualNode
{
public:
    PlotNode(const Transform& transform = {});

    void setContent(Plot* content);

    void setAxisEndStyle(LineEndNode::Style style);

    void update(SceneInfo* sceneInfo) override;

protected:
    void createOrUpdateGeometry(SceneInfo* sceneInfo);

    Plot* mContent{ nullptr };
    bool mContentDirty = true;

    Ptr<LineNode> mXAxis;
    Ptr<LineNode> mYAxis;
    LineEndNode::Style mAxisEndStyle{ LineEndNode::Style::NONE };

    Ptr<PlotCaptionNode> mXAxisCaption;
    Ptr<PlotCaptionNode> mYAxisCaption;

    Vector<Ptr<PlotSeriesNode> > mSeries;

};

