#pragma once

#include "IFontEngine.h"
#include "FontGlyph.h" 

#include "Pointer.h"
#include "String.h"
#include Map.h

class FontsManager
{
public:
    FontsManager();
    static Ptr<FontsManager> Create();

    IFontEngine* getFontEngine() const;

    bool usesGlyphs() const;

    FontGlyph* getGlyph(const String& fontFace, float size, uint32_t c);

private:
    bool mUsesGlyphs{ false };
    Ptr<IFontEngine> mFontEngine;
    Map<uint32_t, Ptr<FontGlyph> > mGlyphs;
};

using FontsManagerPtr = Ptr<FontsManager>;
