#pragma once

#include "Pointer.h"

class Scene;
class Image;

class DrawingSurface
{
public:
    DrawingSurface();
    virtual ~DrawingSurface() = default;

    static Ptr<DrawingSurface> Create();

    virtual void setSize(unsigned width, unsigned height, bool triggerResize = true);

    unsigned getWidth() const;

    unsigned getHeight() const;

    Image* getImage();

    Scene* getScene();

protected:
    unsigned mWidth = 0;
    unsigned mHeight = 0;
    Ptr<Scene> mScene;
    Ptr<Image> mBackingImage;
};
