#pragma once

#include "Pointer.h"
#include "Vector.h"

class DrawingContext;
class OpenGlShaderProgram;
class SceneModel;

class OpenGlMeshPainter
{
public:
    OpenGlMeshPainter();

    void paint(SceneModel* model, DrawingContext* context);

private:
    void initializeShader();
    void initializeBuffers();

    void paint(const Vector<float>& verts, const Vector<size_t>& elements, const Vector<float>& color, bool lines = false);

    unsigned mVertexBuffer{0};
    unsigned mElementBuffer{0};
    unsigned mVertexArray{0};
    Ptr<OpenGlShaderProgram> mShaderProgram;
};
