#pragma once

#include Map.h
#include "Pointer.h"

class DrawingContext;
class OpenGlFontTexture;
class OpenGlShaderProgram;

class TextData;
class SceneText;

class OpenGlTextPainter
{
public:
    OpenGlTextPainter();

    void paint(SceneText* text, DrawingContext* context);

private:
    void initializeShader();
    void initializeTextures(const TextData& textData, DrawingContext* context);

    void initializeBuffers();

    unsigned mVertexBuffer{0};
    unsigned mVertexArray{0};
    Ptr<OpenGlShaderProgram> mShaderProgram;
    Map<char, Ptr<OpenGlFontTexture> > mFontTextures;
};
