#pragma once

#include "TriMesh.h"
#include "LineMesh.h"
#include "Point.h"

#include "Pointer.h"

using EdgeIds = Vector<std::pair<size_t, size_t> >;
using FaceIds = Vector<Vector<size_t> >;
using VecPoints = Vector<Point3>;

class MeshBuilder
{
public:
    static Ptr<TriMesh> buildTriMesh(const VecPoints& locations, const EdgeIds& edgeIds, const FaceIds& faceIds);

    static Ptr<LineMesh> buildLineMesh(const VecPoints& locations, const EdgeIds& edgeIds);
};
