#pragma once

#include "AbstractFace.h"
#include "Vector.h"

class Edge;

class TriFace : public AbstractFace
{
public:
    TriFace(Edge* edge0, Edge* edge1, Edge* edge2, size_t id=0);

    ~TriFace();

    static Ptr<TriFace> Create(Edge* edge0, Edge* edge1, Edge* edge2, size_t id=0);

    void associateWidthEdges() override;

    Vector<size_t> getNodeIds() const override;

    size_t getNumNodes() const override;

    void replaceEdge(Edge* original, Edge* replacement) override;

    size_t getEdge0Id () const;
    size_t getEdge1Id () const;
    size_t getEdge2Id () const;
    Vector<size_t> getEdgeIds() const override;

    Vector<Point3> getNodeLocations(Orientation orientation = Orientation::CCW) const override;

    Vector3 getNormal() const;

    AbstractFace::Orientation getOrientation() const;

private:
    Edge* mEdge0{nullptr};
    Edge* mEdge1{nullptr};
    Edge* mEdge2{nullptr};
};
