#pragma once

#include "MaterialNode.h"
#include "Color.h"

class SceneModel;

class GridNode : public MaterialNode
{
public:
    GridNode(const Transform& transform);

    virtual ~GridNode();

    void setNumX(size_t numX);

    void setNumY(size_t numY);

    void setData(const Vector<Color>& colors);

    SceneItem* getSceneItem(size_t idx) const override;
    size_t getNumSceneItems() const override;

    void update(SceneInfo* sceneInfo) override;

    void setWidth(double width);
    void setHeight(double height);

private:
    size_t mNumberX{5};
    size_t mNumberY{5};
    double mWidth{1};
    double mHeight{1};

    bool mDataDirty = true;
    bool mGeometryIsDirty = true;

    Vector<Color> mData;

    Ptr<SceneModel> mBackgroundModel;
    Ptr<SceneModel> mOutlineModel;
};
