#pragma once

#include "SvgElement.h"
#include "Color.h"
#include "Transform.h"

class SvgShapeElement : public SvgElement
{
public:
    SvgShapeElement(const String& tagName, size_t precision = 0);

    Transform getTransform() const;
    
    bool hasTransform() const;

    void setFill(const Color& fill);

    void setNoFill();

    void setFillOpacity(float opacity);

    void setStrokeWidth(double width);

    void setStrokeColor(const Color& stroke);

    void setNoStroke();

protected:
    size_t mPrecision{ 0 };

private:
    String getLabelledContent(const String& key, const String& content) const;
    Point2 parsePoint(const String& pointString, double defaultVal = 0.0) const;
};
