#pragma once

#include "Pointer.h"
#include "String.h"

#include "UiEvent.h"
#include "Keyboard.h"

class KeyboardEvent : public UiEvent
{
public:
    enum class Action
    {
        Pressed,
        Released
    };

public:

    KeyboardEvent();

    ~KeyboardEvent();

    static Ptr<KeyboardEvent> Create();

    void setKeyString(const String& key);

    String getKeyString() const;

    void setAction(Action action);

    Action getAction() const;

    bool isFunctionKey() const;

    Keyboard::Function getFunction() const;

    void setFunction(Keyboard::Function function);

private:

    Keyboard::Function mFunction{Keyboard::Function::UNSET};
    Action mAction;
    String mKeyString;

};
using KeyboardEventUPtr = Ptr<KeyboardEvent>;
