#pragma once

#include "Vector.h"
#include "Pointer.h"

class MarkdownElement;
class MarkdownLink;
class MarkdownCustomMultilineElementContext;
class MarkdownCustomInlineElementContext;

class MarkdownDocument
{
public:
    ~MarkdownDocument();

    void addElement(Ptr<MarkdownElement> element);

    size_t getNumElements() const;

    MarkdownElement* getElement(size_t idx) const;

    Vector<MarkdownLink*> getAllLinks() const;

    size_t getNumMultilineContexts() const;

    size_t getNumInlineContexts() const;

    MarkdownCustomMultilineElementContext* getMultilineContext(size_t idx) const;

    MarkdownCustomInlineElementContext* getInlineContext(size_t idx) const;

    void registerCustomInlineElement(Ptr<MarkdownCustomInlineElementContext> context);

    void registerCustomMultilineElement(Ptr<MarkdownCustomMultilineElementContext> context);

private:
    Vector<Ptr<MarkdownElement> > mElements;
    Vector<Ptr<MarkdownCustomMultilineElementContext> > mCustomMultilineContexts;
    Vector<Ptr<MarkdownCustomInlineElementContext> > mCustomInlineContexts;
};


