#pragma once

#include "String.h"

class MarkdownElement
{
public:
    enum class Type
    {
        HEADING,
        PARAGRAPH,
        TEXT_SPAN,
        INLINE_QUOTE,
        MULTILINE_QUOTE,
        CUSTOM_INLINE,
        CUSTOM_MULTILINE,
        LINK,
        IMAGE,
        BULLET_ITEM,
        BULLET_LIST
    };

    virtual ~MarkdownElement() = default;

    void appendTextContent(const String& content);

    void addLine(const String& line);

    virtual String getTextContent() const;

    virtual Type getType() const = 0;

    virtual void doFieldSubstitution(Type, const String&, const String&)
    {

    }
private:
    String mTextContent;
};

class MarkdownInlineElement : public MarkdownElement
{
public:
    virtual ~MarkdownInlineElement() = default;
};

class MarkdownMultilineElement : public MarkdownElement
{
public:
    virtual ~MarkdownMultilineElement() = default;
};
